<!doctype html>
<html lang="en">
<head>
    <!--
       This work is marked with CC0 1.0
       https://creativecommons.org/publicdomain/zero/1.0/legalcode.txt
    -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>eper.io℠</title>
    <link href="/res/bootstrap-5.3.2-dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-T3c6CoIi6uLrA9TneNEoa7RxnatzjcDSCmG1MXxSR1GAsXEV/Dwwykc2MPK8M2HN" crossorigin="anonymous">
    <link rel="icon" href="/res/logo.png" type="image/png">
    <title>eper.io℠</title>
    <style>
        body {
            font-family: system-ui;
            font-size: medium;
        }
        @media only screen and (min-width: 1025px) {
            font-family: system-ui;
            font-size: large;
            body {
                /*transform: scale(2.4);*/
            }
        }
        #toolbar {
            margin: 5px;
            padding: 20px;
            background-color: aliceblue;
            box-shadow: 5px 5px 5px 0px rgba(0,0,0,0.15);
        }
        #sat-edit {
            margin: 5px;
            font-family: Arial;
            box-shadow: 5px 5px 5px 0px rgba(0,0,0,0.15);
        }
    </style>
</head>
<body>
<script src="/res/bootstrap-5.3.2-dist/js/bootstrap.bundle.min.js" integrity="sha384-C6RzsynM9kWDrMNeT87bh95OGNyZPhcTNXj1NW7RuBCsyN/o0jlpcV8Qyq46cDfL" crossorigin="anonymous"></script>
<div id="toolbar" style="margin-left: 0.5in;margin-right: 0.5in;right:10%;width:80%;height: auto;">
    <label for="new"></label>
    <input type="button" id="new" value="New" onclick="window.location.href = window.location.origin + window.location.pathname;">
    <div id="toolbar-edit-tools" hidden>
        <label for="fontType">Font Type:</label>
        <select id="fontType">
            <option value="Arial">Arial</option>
            <option value="Verdana">Verdana</option>
            <option value="Courier New">Courier New</option>
            <option value="Times New Roman">Times New Roman</option>
        </select>
        <label for="bold">Bold:</label>
        <input type="checkbox" id="bold">
        <label for="italic">Italic:</label>
        <input type="checkbox" id="italic">
        <label for="color">Color:</label>
        <input type="color" id="color">
        <label for="bigger"></label>
        <input type="button" id="bigger" value="Bigger" onclick="biggerFont()">
        <label for="smaller"></label>
        <input type="button" id="smaller" value="Smaller" onclick="smallerFont()">
        <label for="done"></label>
        <input type="button" id="done" value="Done" onclick="document.getElementById('sat-edit').contentEditable='false';document.getElementById('toolbar-edit-tools').hidden=true;document.getElementById('toolbar-view-tools').hidden=false;">
    </div>
    <div id="toolbar-view-tools">
        <label for="edit"></label>
        <input type="button" id="edit" value="Modify" onclick="document.getElementById('sat-edit').contentEditable='true';document.getElementById('toolbar-edit-tools').hidden=false;document.getElementById('toolbar-view-tools').hidden=true;">
    </div>
</div>
<div id='sat-edit' contenteditable="true" style="margin-left: 0.5in;margin-right: 0.5in;right:10%;width:80%;height: auto;"><p class="sat-paragraph">Enter text here.</p></div>
<script>
    function rgbToHex(rgb) {
        let a = rgb.split("(")[1].split(")")[0];
        a = a.split(",");
        let b = a.map(function(x){
            x = parseInt(x).toString(16);
            return (x.length==1) ? "0"+x : x;
        });
        return "#" + b.join("");
    }
    function biggerFont() {
        let savedSelection = window.getSelection();
        let selection = savedSelection.getRangeAt(0);
        let selectedText = selection.extractContents();
        let span = document.createElement("span");
        span.appendChild(selectedText);
        selection.insertNode(span);
        let style = window.getComputedStyle(span, null).getPropertyValue('font-size');
        let fontSize = parseFloat(style);
        span.style.fontSize = (fontSize + fontSize * 0.10) + 'px';
        setSelection(span)
    }
    function smallerFont() {
        let savedSelection = window.getSelection();
        let selection = savedSelection.getRangeAt(0);
        let selectedText = selection.extractContents();
        let span = document.createElement("span");
        span.appendChild(selectedText);
        selection.insertNode(span);
        let style = window.getComputedStyle(span, null).getPropertyValue('font-size');
        let fontSize = parseFloat(style);
        span.style.fontSize = (fontSize - fontSize * 0.10) + 'px';
        setSelection(span)
    }
    function setSelection(x) {
        let element = x
        let range = document.createRange();
        range.selectNodeContents(element);
        let sel = window.getSelection();
        sel.removeAllRanges();
        sel.addRange(range);
    }
    let paragraph = document.getElementById('sat-edit');
    let fontType = document.getElementById('fontType');
    let bold = document.getElementById('bold');
    let italic = document.getElementById('italic');
    let color = document.getElementById('color');
    let fontSize = document.getElementById('fontSize');
    let bigger = document.getElementById('bigger');
    let smaller = document.getElementById('smaller');

    document.addEventListener('selectionchange', function() {
        let selection = window.getSelection();
        if (selection.rangeCount > 0) {
            let range = selection.getRangeAt(window.getSelection().rangeCount-1);
            let parentElement = range.endContainer.parentElement;
            x = window.getComputedStyle(parentElement).fontFamily;
            x = x.replace(/"/g,'')
            console.log(x)
            fontType.value = x
            bold.checked = window.getComputedStyle(parentElement).fontWeight === '700';
            italic.checked = window.getComputedStyle(parentElement).fontStyle === 'italic';
            color.value = rgbToHex(window.getComputedStyle(parentElement).color);
            let y = window.getComputedStyle(parentElement).fontSize;
            console.log(window.getComputedStyle(parentElement).fontSize)
        }
    });

    fontType.addEventListener('change', function() {
        document.execCommand('fontName', false, this.value);
    });
    bold.addEventListener('change', function() {
        document.execCommand('bold', false, null);
    });
    italic.addEventListener('change', function() {
        document.execCommand('italic', false, null);
    });
    color.addEventListener('change', function() {
        document.execCommand('foreColor', false, this.value);
    });
    bigger.addEventListener('click', function() {
        console.log(this.value)
        biggerFont()
    });
    smaller.addEventListener('click', function() {
        console.log(this.value)
        smallerFont()
    });
</script>
<script>
    async function poke(content) {
        return await fetch('/sat/data?format=%25s', {method: 'PUT', body: content}).then(x => {
            if (x.ok) {
                return x.text()
            }
            return ''
        })
    }
    async function get(locator) {
        let a = '/sat/data'+locator
        console.log(a)
        let z = await fetch(a, {method: 'GET'}).then(x=>{
            if (x.ok) {
                return x.text()
            }
            return ''
        }).then(y=>{return y})
        document.getElementById('sat-edit').innerHTML=z
    }
    console.log('Loaded.', window.location.hash)
    if (window.location.hash.startsWith('#apikey=')) {
        let locator = '/'+window.location.hash.substring('#apikey='.length)+'.tig'
        get(locator)
    }
    let doc = ''
    setInterval(function () {
        if (document.getElementById('sat-edit').hidden) {
            return
        }
        let nw = document.getElementById('sat-edit').innerHTML
        if (doc !== nw) {
            doc = nw
            let a = poke(doc)
            async function Hash() {
                const msgUint8 = new TextEncoder().encode(doc);
                const hashBuffer = await crypto.subtle.digest("SHA-256", msgUint8);
                const hashArray = Array.from(new Uint8Array(hashBuffer));
                const hashHex = hashArray.map((b) => b.toString(16).padStart(2, "0")).join("");
                return hashHex;
            }
            a.then(x=>console.log('change','/data'+x))
            Hash().then(x=>{window.location.hash='apikey='+x;})
        }
    }, 1000)

    paragraph.addEventListener('paste', function(event) {
        event.preventDefault();

        let pastedText = (event.clipboardData || window.clipboardData).getData('text');

        let urlRegex = /^(https?:\/\/)?(([\da-z\.-]+)\.([a-z\.]{2,6})([\/\w \.-]*)*\/?)$/;
        if(urlRegex.test(pastedText)) {
            let a = document.createElement('a');
            a.href = pastedText;
            a.textContent = pastedText;
            insertAtCursor(paragraph, a);
        } else {
            insertAtCursor(paragraph, document.createTextNode(pastedText));
        }
    });

    paragraph.addEventListener('paste', function(event) {
        let items = (event.clipboardData || event.originalEvent.clipboardData).items;
        for (let index in items) {
            let item = items[index];
            console.log(item)
            if (item.kind === 'file' && item.type.indexOf('image') !== -1) {
                event.preventDefault();

                let blob = item.getAsFile();

                let formData = new FormData();
                formData.append('file', blob);

                let img = document.createElement('img');
                fetch('https://tmp.schmied.us?format=https://tmp.schmied.us%25s', {
                    method: 'PUT',
                    body: formData
                })
                .then(response => {
                    img.src = response.url;
                })
                .catch(error => {
                    img.src = 'https://tmp.schmied.us/c92b8a9e1cbdcbcf6fb03be36e8a641277d574edfc328fcebdadfc626d94e441.tig?Content-Type=image/png'
                    console.error(error)
                });
                img.onload = function() {
                    let clientWidth = paragraph.clientWidth;
                    img.style.width = (clientWidth / 2) + 'px';
                    let aspectRatio = this.naturalHeight / this.naturalWidth;
                    img.style.height = (clientWidth / 2 * aspectRatio) + 'px';

                    //img.style.width = (paragraph.naturalWidth / 2) + 'px';
                    //img.style.height = (paragraph.naturalHeight / 2) + 'px';
                    // Align the image to the horizontal center
                    img.style.display = 'block';
                    img.style.margin = '0 auto';
                    insertAtCursor(paragraph, img);
                };
                return
            } else {
                event.preventDefault();

                let pastedText = (event.clipboardData || window.clipboardData).getData('text');

                let urlRegex = /^(https?:\/\/)?(([\da-z\.-]+)\.([a-z\.]{2,6})([\/\w \.-]*)*\/?)$/;
                if(urlRegex.test(pastedText)) {
                    let a = document.createElement('a');
                    a.href = pastedText;
                    a.textContent = pastedText;
                    insertAtCursor(paragraph, a);
                } else {
                    insertAtCursor(paragraph, document.createTextNode(pastedText));
                }
                return
            }
        }
    });


    function insertAtCursor(parentNode, newNode) {
        parentNode.focus();
        if(window.getSelection && window.getSelection().getRangeAt) {
            let range = window.getSelection().getRangeAt(0);
            range.deleteContents();
            range.insertNode(newNode);
        } else if(document.selection && document.selection.createRange) {
            document.selection.createRange().pasteHTML(newNode.outerHTML);
        }
    }
</script>
</body>
</html>